LeetCode 392. Is Subsequence

Given a string s and a string t, check if s is subsequence of t.

You may assume that there is only lower case English letters in both s and t. t is potentially a very long (length ~= 500,000) string, and s is a short string (<=100).

A subsequence of a string is a new string which is formed from the original string by deleting some (can be none) of the characters without disturbing the relative positions of the remaining characters. (ie, "ace" is a subsequence of "abcde" while "aec" is not).

Example 1:
s = "abc", t = "ahbgdc"

Return true.

Example 2:
s = "axc", t = "ahbgdc"

Return false.

分析

这道题我先是用动态规划和二维数组来做的,但空间不够

class Solution {
public:
    bool isSubsequence(string s, string t) {
         int dp[s.size()+1][t.size()+1];
         for(int i=0;i<=t.size();i++)
             dp[0][i]=1;
         for(int i=1;i<=s.size();i++){
             dp[i][0]=0;
             for(int j=1;j<=t.size();j++) 
                 if(s[i-1]==t[j-1])
                    dp[i][j]=dp[i-1][j-1]==1?1:0;
                 else
                    dp[i][j]=dp[i][j-1];
         }
         if(dp[s.size()][t.size()]==1)
             return true;
         else
             return false;
    }
};

接着,我压缩了空间,变为一维数组,虽然ac了,并且可以继续在此基础继续做一些优化,但效果不明显。

class Solution {
public:
    bool isSubsequence(string s, string t) {
         int dp[t.size()+1];
         for(int i=0;i<=t.size();i++)
             dp[i]=1;
         for(int i=1;i<=s.size();i++){
         	 int t1=dp[0];
             dp[0]=0;
             for(int j=1;j<=t.size();j++){
			    int t2=dp[j];
             	if(s[i-1]==t[j-1])
                    dp[j]=t1==1?1:0;
                else
                    dp[j]=dp[j-1];
                t1=t2;
			 }  
         }
         if(dp[t.size()]==1)
            return true;
         else 
            return false;
    }
};

本着不断优化的想法,还可以不用动态规划,其实这也是最容易想到的办法,但因为最近在集中训练动态规划,所以把这个办法放到了最后

class Solution {
public:
    bool isSubsequence(string s, string t) {
         int index=0;
         for(int i=0;i<t.size()&&index<s.size();i++)
             if(s[index]==t[i])
                  index++;
         if(index==s.size())
             return true;
         else
             return false;
        
    }
};
posted @ 2018-02-10 16:35  A-Little-Nut  阅读(129)  评论(0编辑  收藏  举报